//
// Set up NODE ENV

if (process.env.NODE_ENV === 'development') {
  global.NODE_ENV = 'development';
} else {
  global.NODE_ENV = 'production';
}


//
// App code

const editor = require('./editor');
const leftPane = require('./leftpane');
const fileDrop = require('./filedrop');
const fileSync = require('./filesync');
const onboarding = require('./onboarding');
const docsManager = require('./docs-manager');

function startApp() {
  docsManager.init()
  editor.init();
  leftPane.init();
  fileSync.init();
  fileDrop.init();
}

function init() {
  onboarding.init(startApp)

  // Prevent Trackpad Zoom
  require('electron').webFrame.setZoomLevelLimits(1, 1);
}


exports.init = init;
