const os = require('os')
const path = require('path')
const fs = require('fs-extra')
const ElectronSettings = require('electron-settings')

const config = {}

config.settings = new ElectronSettings()

config.paletteFolderPath = os.homedir() + '/Library/Colors/OpenColorCache/'
config.colorPickersFolderPath = os.homedir() + '/Library/ColorPickers/'
config.sketchPluginsFolderPath = os.homedir() + '/Library/Application Support/com.bohemiancoding.sketch3/Plugins'
config.sketchPluginPath = config.sketchPluginsFolderPath + '/opencolortools.sketchplugin'
config.sketchPickerHelperPluginPath = config.sketchPluginsFolderPath + '/PickerHelper.sketchplugin'
config.homedir = os.homedir()
config.documentsFolderPath = os.homedir() + '/Documents'
config.colorPickerName = 'OpenColorPicker.colorPicker'
config.colorPickerPath = config.colorPickersFolderPath + config.colorPickerName

config.isValidFile = function (name) {
  return (path.extname(name) === '.oco')
}

config.isValidFileForImport = function (name) {
  const extName = path.extname(name).toLowerCase()
  return (
    extName === '.oco' ||
    // extName === '.aco' ||
    extName === '.css' ||
    extName === '.less' ||
    // extName === '.json' ||
    extName === '.scss' ||
    extName === '.aco' ||
    extName === '.png' ||
    extName === '.jpg' ||
    extName === '.jpeg' ||
    extName === '.sketchpalette'
  )
}

module.exports = config
