const templates = require('../templates');
const filedrop = require('../filedrop');
var closeListener = function() {};
var $assistant = null;

function show() {
  $('body').data('assistant', true);
  $assistant = $(templates.assistant({}));
  $('[data-document-modal-container]').html('').removeClass('is-hidden').append($assistant);

  $assistant.find('[data-assistant-template]').click(function() {
    const $trigger = $(this);

    var templateName = $trigger.data('assistant-template');
    closeWithTemplate(templateName);
  });

  $assistant.find('[data-open-from-disk]').click(function(e) {
    e.preventDefault();
    filedrop.showChooseFileDialog();
  })

  $(document).bind('keyup.assistant', (e) => {
    const ESC = 27;
    const ENTER = 13;
    const TAB = 9;

    if (e.keyCode == ENTER) {
      const $trigger = $('[data-assistant-template-selected=true]');
      var templateName = $trigger.data('assistant-template');
      closeWithTemplate(templateName);
    } else if (e.keyCode == ESC) {
      cancel()
    } else if (e.keyCode == TAB) {
      var $current = $('[data-assistant-template-selected=true]');
      var $next = $current.next();
      if(!$next.size()) {
        $next = $('[data-assistant-template]').first();
      }
      // make ist accessible for css
      $current.attr('data-assistant-template-selected', 'false');
      $next.attr('data-assistant-template-selected', 'true');
      e.stopPropagation();
    }
  });
}

function closeWithTemplate(templateName) {
  const oco = templates.loadOcoTemplate(templateName);
  if(!oco) {
    throw('Could not load oco template ' + templateName);
  } else {
    close(oco)
  }
}

function removeUI() {
  $('body').data('assistant', false);
  $(document).unbind('keyup.assistant');
  if(!$assistant) {
    return;
  }
  $assistant.hide();
  $('[data-document-modal-container]').addClass('is-hidden');
}

function close(ocoString) {
  removeUI();
  closeListener(ocoString);
}

function cancel() {
  removeUI();
  closeListener(false);
}

function init(_closeListener) {
  closeListener = _closeListener;
  $('body').on('fieldropdragenter.oct', function() {
    $('[data-document-assistant-dropzone]').addClass('is-active');
  });
  $('body').on('fieldropdragleave.oct', function() {
    $('[data-document-assistant-dropzone]').removeClass('is-active');
  });
}

module.exports = {
  init: init,
  close: close,
  show: show
}
