var submitListener;
var cancelListener;
var title;
var $input;

function onSubmitTitle() {
  $input.prop('readonly', true);
  $input.removeClass('is-editing');
  var val = $input.val();
  submitListener(val);
}

function onEditTitle() {
}

function startEditTitle() {
  $input.prop('readonly', false);
  $input.addClass('is-editing');
  $input.val(title);
  $input.data('valueBeforeEdit', $('[data-title-field] input').val());
  $input.focus();
}

function cancelTitle() {
  var valueBeforeEditing = $input.data('valueBeforeEdit');
  if (valueBeforeEditing) {
    $input.val(valueBeforeEditing);
  }
  $input.data('valueBeforeEdit', '');
  $input.prop('readonly', true);
  $input.removeClass('is-editing');

  cancelListener();
}

function stopEditTitle() {
  cancelTitle();
}

function updateUI(currentDoc) {
  title = currentDoc.newTitle || currentDoc.title;
  $input.val(title);
  $('[data-last-modified]').text(currentDoc.lastModified);
}

function init(_submitListener, _cancelListener) {
  submitListener = _submitListener;
  cancelListener = _cancelListener;
  $input = $('.Document [data-title-input]');
  $('.Document').on('click', '[data-title-input]:not(.is-editing)', startEditTitle);
  $input.on('keyup change', onEditTitle);
  $input.on('blur', onSubmitTitle);

  $input.on('keyup', (e) => {
    const ESC = 27;
    const ENTER = 13;
    if (e.keyCode == ENTER) {
      onSubmitTitle();
    } else if (e.keyCode == ESC) {
      cancelTitle();
    }
  });
}

module.exports = {
  init: init,
  startEditTitle: startEditTitle,
  stopEditTitle: stopEditTitle,
  updateUI: updateUI
}
