const templates = require('../templates');

function openDialog(title, callback) {
  var data = {
    title: title
  };
  var $alert = $(templates.renamePaletteModal(data));

  var $input = $alert.find('[data-options] input[name="name"]');

  $alert.find('[data-cancel]').on('click', function(e) {
    e.preventDefault();
    callback(false);
    closeDialog();
  });

  function submit(e) {
    e.preventDefault();
    callback($input.val());
    closeDialog();
  }
  $alert.find('[data-options]').submit(submit);
  $alert.find('[data-submit]').on('click', submit);

  $('[data-app-modal-container]').append($alert).removeClass("is-hidden");

  setTimeout(function() {
    $alert.removeClass("is-hidden");
    $input.focus().select();
  }, 30);
}

function closeDialog() {
  $('[data-rename-palette-overlay]').addClass("is-hidden");

  setTimeout(function() {
    $('[data-rename-palette-overlay]').remove();
    $('[data-app-modal-container]').addClass("is-hidden");
  }, 600);
}


exports.openDialog = openDialog;
exports.closeDialog = closeDialog;
