function readFormOptions($elm) {
  var optionsArray = $elm.serializeArray();
  var options = {};
  optionsArray.forEach(function(pair) {
    if(pair.value === "false") {
      options[pair.name] = false;
      return;
    }
    if(pair.value === "true") {
      options[pair.name] = true;
      return;
    }
    if(pair.value.indexOf('__arrify:') === 0) {
      options[pair.name] = pair.value.replace('__arrify:', '').split(',');
      return;
    }
    options[pair.name] = pair.value;
  })
  return options;
}

function switchPromisable(enabled, promiseFunction) {
  if(!enabled) {
    return function(tree) {
      return Promise.resolve(tree)
    }
  }
  return promiseFunction;
}

module.exports = {
  readFormOptions: readFormOptions,
  switchPromisable: switchPromisable
}
