import React from 'react'
import BaseView from './BaseView'
import Float from '../Float/Float'

export default class BarsView extends BaseView {
  constructor (props) {
    super(props)

    this.options = {
      showName: this.optionValue(props.options.showName, true),
      showValue: this.optionValue(props.options.showValue, true),
      backgroundColor: this.optionValue(props.options.backgroundColor, '#FFFFFF'),
      colorsPerRow: 1,
      swatchShape: 'RECT',
      swatchShapeRounded: false
    }
  }

  render () {
    let floatProps = {
      entries: this.props.entries,
      name: this.props.name,
      options: this.options
    }

    return (
      <Float {...floatProps} />
    )
  }
}

BarsView.propTypes = {
  entries: React.PropTypes.array.isRequired,
  name: React.PropTypes.string,
  options: React.PropTypes.object
}
