import React from 'react'
import BaseView from './BaseView'
import Grid from '../Grid/Grid'

export default class BlockView extends BaseView {
  constructor (props) {
    super(props)

    this.options = {
      showName: this.optionValue(props.options.showName, false),
      showValue: this.optionValue(props.options.showValue, false),
      backgroundColor: this.optionValue(props.options.backgroundColor, '#FFFFFF'),
      colorsPerRow: 1,
      swatchShape: 'RECT',
      groupShapeRounded: false,
      groupMargin: false
    }
  }

  render () {
    let gridProps = {
      entries: this.props.entries,
      name: this.props.name,
      options: this.options
    }

    return (
      <Grid {...gridProps} />
    )
  }
}

BlockView.propTypes = {
  entries: React.PropTypes.array.isRequired,
  name: React.PropTypes.string,
  options: React.PropTypes.object
}
