import React from 'react'
import BaseView from './BaseView'
import Float from '../Float/Float'

export default class CardsView extends BaseView {
  constructor (props) {
    super(props)

    var colorsPerRow = this.optionValue(props.options.colorsPerRow, 3)
    colorsPerRow = Math.max(colorsPerRow, 2)
    colorsPerRow = Math.min(colorsPerRow, 6)

    this.options = {
      showName: this.optionValue(props.options.showName, true),
      showValue: this.optionValue(props.options.showValue, true),
      colorsPerRow: colorsPerRow,
      backgroundColor: this.optionValue(props.options.backgroundColor, '#FFFFFF'),
      swatchShape: 'SQUARE',
      swatchShapeRounded: true
    }
  }

  render () {
    let floatProps = {
      entries: this.props.entries,
      name: this.props.name,
      options: this.options
    }

    return (
      <Float {...floatProps} />
    )
  }
}

CardsView.propTypes = {
  entries: React.PropTypes.array.isRequired,
  name: React.PropTypes.string,
  options: React.PropTypes.object
}
