import React from 'react'
import BaseView from './BaseView'
import Flex from '../Flex/Flex'

export default class FanView extends BaseView {
  constructor (props) {
    super(props)

    this.options = {
      showName: this.optionValue(props.options.showName, false),
      showValue: this.optionValue(props.options.showValue, false),
      backgroundColor: this.optionValue(props.options.backgroundColor, '#FFFFFF'),
      swatchShape: 'RECT'
    }
  }

  render () {
    let floatProps = {
      entries: this.props.entries,
      name: this.props.name,
      options: this.options
    }

    return (
      <Flex {...floatProps} />
    )
  }
}

FanView.propTypes = {
  entries: React.PropTypes.array.isRequired,
  name: React.PropTypes.string,
  options: React.PropTypes.object
}
