import React from 'react'
import BaseView from './BaseView'
import Grid from '../Grid/Grid'

export default class GridView extends BaseView {
  constructor (props) {
    super(props)

    var colorsPerRow = this.optionValue(props.options.colorsPerRow, 3)
    colorsPerRow = Math.max(colorsPerRow, 2)

    this.options = {
      showName: this.optionValue(props.options.showName, false),
      colorsPerRow: colorsPerRow,
      backgroundColor: this.optionValue(props.options.backgroundColor, '#FFFFFF'),
      groupShapeRounded: false,
      showValue: this.optionValue(props.options.showValue, false),
      groupMargin: false,
      swatchShape: 'RECT',
      view: 'GridView'
    }
  }

  render () {
    let gridProps = {
      entries: this.props.entries,
      name: this.props.name,
      options: this.options
    }

    return (
      <Grid {...gridProps} />
    )
  }
}

GridView.propTypes = {
  entries: React.PropTypes.array.isRequired,
  name: React.PropTypes.string,
  options: React.PropTypes.object
}
