import React from 'react'
import BaseView from './BaseView'
import Table from '../Table/Table'

export default class ListView extends BaseView {
  constructor (props) {
    super(props)

    this.options = {
      showValue: this.optionValue(props.options.showValue, true),
      swatchShape: this.optionValue(props.options.swatchShape, 'CIRCLE'),
      backgroundColor: this.optionValue(props.options.backgroundColor, '#FFFFFF'),
      swatchShapeRounded: true
    }
  }

  render () {
    let tableProps = {
      entries: this.props.entries,
      name: this.props.name,
      options: this.options
    }

    return (
      <Table {...tableProps} />
    )
  }
}

ListView.propTypes = {
  entries: React.PropTypes.array.isRequired,
  name: React.PropTypes.string,
  options: React.PropTypes.object
}
