import React from 'react'
import BaseView from './BaseView'
import Float from '../Float/Float'

export default class MinimalView extends BaseView {
  constructor (props) {
    super(props)

    this.options = {
      swatchShape: this.optionValue(props.options.swatchShape, 'CIRCLE'),
      backgroundColor: this.optionValue(props.options.backgroundColor, '#FFFFFF'),
      showName: false,
      showValue: false,
      colorsPerRow: 10,
      swatchShapeRounded: true,
      fixedSize: true
    }
  }

  render () {
    let floatProps = {
      entries: this.props.entries,
      name: this.props.name,
      options: this.options
    }

    return (
      <Float {...floatProps} />
    )
  }
}

MinimalView.propTypes = {
  entries: React.PropTypes.array.isRequired,
  name: React.PropTypes.string,
  options: React.PropTypes.object
}
