import React from 'react'
import BaseView from './BaseView'
import Float from '../Float/Float'

export default class SamplesView extends BaseView {
  constructor (props) {
    super(props)

    var colorsPerRow = this.optionValue(props.options.colorsPerRow, 2)
    colorsPerRow = Math.max(colorsPerRow, 1)
    colorsPerRow = Math.min(colorsPerRow, 3)

    this.options = {
      showName: true,
      showValue: true,
      colorsPerRow: colorsPerRow,
      backgroundColor: this.optionValue(props.options.backgroundColor, '#FFFFFF'),
      swatchShape: 'SQUARE',
      swatchShapeRounded: true,
      view: 'SamplesView'
    }
  }

  render () {
    let floatProps = {
      entries: this.props.entries,
      name: this.props.name,
      options: this.options
    }

    return (
      <Float {...floatProps} />
    )
  }
}

SamplesView.propTypes = {
  entries: React.PropTypes.array.isRequired,
  name: React.PropTypes.string,
  options: React.PropTypes.object
}
