import React from 'react'
import BaseView from './BaseView'
import Grid from '../Grid/Grid'

export default class SquaresView extends BaseView {
  constructor (props) {
    super(props)

    this.options = {
      colorsPerRow: this.optionValue(props.options.colorsPerRow, 10),
      backgroundColor: this.optionValue(props.options.backgroundColor, '#FFFFFF'),
      swatchShape: 'SQUARE',
      showName: false,
      showValue: false,
      groupShapeRounded: false,
      groupMargin: true
    }
  }

  render () {
    let gridProps = {
      entries: this.props.entries,
      name: this.props.name,
      options: this.options
    }

    return (
      <Grid {...gridProps} />
    )
  }
}

SquaresView.propTypes = {
  entries: React.PropTypes.array.isRequired,
  name: React.PropTypes.string,
  options: React.PropTypes.object
}
