import React from 'react'
import ReactDOM from 'react-dom'
import {parse} from 'opencolor'

import TestingApp from './components/TestingApp/TestingApp'
import ColorPicker from './components/ColorPicker/ColorPicker'
import Error from './components/Error/Error'

var ocoRendererApi = {
  parse (data) {
    return parse(data)
  },

  render (parsedOco, container) {
    ReactDOM.render(<ColorPicker parsedOco={parsedOco} />, container)
  },

  parseAndRender (data, container) {
    try {
      let parsedOco = parse(data)
      ReactDOM.render(<ColorPicker parsedOco={parsedOco} />, container)
    } catch (err) {
      ReactDOM.render(<Error error={err} />, container)
    }
  },

  destroy (container) {
    ReactDOM.unmountComponentAtNode(container)
  },

  renderTesting (container) {
    ReactDOM.render(<TestingApp />, container)
  }
}

module.exports = ocoRendererApi
