export const getLuminanceForHex = function (colorHex) {
  var c = colorHex.substring(1)      // strip #
  var rgb = parseInt(c, 16)   // convert rrggbb to decimal
  var r = (rgb >> 16) & 0xff  // extract red
  var g = (rgb >> 8) & 0xff  // extract green
  var b = (rgb >> 0) & 0xff  // extract blue

  var luma = 0.2126 * r + 0.7152 * g + 0.0722 * b // per ITU-R BT.709
  luma = Math.round((luma / 255) * 100)
  return luma
}

export const colorIsLight = function (colorHex) {
  let luma = getLuminanceForHex(colorHex)
  let lumaThreshold = 66

  if (luma > lumaThreshold) {
    return true
  } else {
    return false
  }
}

export const colorIsDark = function (colorHex) {
  let luma = getLuminanceForHex(colorHex)
  let lumaThreshold = 66

  if (luma < lumaThreshold) {
    return true
  } else {
    return false
  }
}

export const colorIsVeryLight = function (colorHex) {
  let luma = getLuminanceForHex(colorHex)
  let lumaThreshold = 90

  if (luma > lumaThreshold) {
    return true
  } else {
    return false
  }
}
