function constructColor (block) {
  let color = {
    name: block.name,
    metadata: block.metadata
  }

  block.forEach(function (child) {
    if (child.type === 'ColorValue' && child.isHexExpressable()) {
      color.value = child.value
      color.hexValue = child.hexcolor()
    }
  })

  let options = {}
  block.metadata.keys().forEach(function (key) {
    if (/^oct\//i.test(key)) {
      let newKey = key.replace(/^oct\//i, '')
      let newValue = block.metadata.get(key)
      options[newKey] = newValue
    }
  })
  color.options = options
  return color
}

export const parseColor = function (block) {
  if (block.type === 'Reference') {
    let color
    let targetBlock = block.resolved()

    if (targetBlock && targetBlock.type === 'Color') {
      color = constructColor(targetBlock)
      color.name = block.name
      color.value = `=${block.refName}`
    } else {
      color = {
        name: '!!! Unresolved Reference',
        value: 'unresolved',
        hexValue: '#ffffff'
      }
    }

    return color
  } else {
    return constructColor(block)
  }
}

export const RenderError = function (message) {
  this.name = 'RenderError'
  this.message = message
  this.toString = function () { return this.name + ': ' + this.message }
}
