var webpack = require('webpack');
var path = require('path');

var NODE_ENV = process.env.NODE_ENV || 'development';

var config = {
  entry: [
    './src/index.js'
  ],

  output: {
    filename: 'index.js',
    path: path.resolve(__dirname, './dist'),
    publicPath: 'dist/',
    libraryTarget: "umd",
    library: "OcoRenderer",
  },

  module: {
    loaders: [
      {
        test: /\.js$/,
        loader: 'babel-loader',
        exclude: /node_modules/,
        query: {
          presets: ['react', 'es2015']
        }
      },
      {
        test: /\.scss$/,
        loaders: [
          'style-loader',
          'css-loader?modules&importLoaders=1&localIdentName=[name]__[local]___[hash:base64:5]',
          'sass-loader',
          'postcss-loader'
        ]
      },
      {
        test: /\.svg$/,
        loader: 'url-loader',
      },
    ]
  },

  plugins: [
    new webpack.DefinePlugin({
      'process.env': {
        NODE_ENV: JSON.stringify(NODE_ENV)
      }
    })
  ],

  postcss: function () {
    require('autoprefixer');
  },

  node: {
    fs: "empty"
  }
};

if (NODE_ENV === 'development') {
  config.devtool = '#source-map';
}

module.exports = config;
